####

library("igraph");
library("xtable");
library("stats4");

setwd("/Users/joemiro/Documents/Investigacion/docencia/Colaboracion/Iticse/Neatdata")

#Get file with Author data

AuData = read.table("WGonly/WGAu.csv", header = T, sep = "\t")
# Cuidado: en ficheros hay un\t de mas excepto en la cabecer
years = 16

#NAu: Number of authors; PxA = Papers per Author
# _Year: values each year
NAuYear = rep(0,years)
MeanPxAYear = rep(0,years)

for (i in 1:years)
  { tmp = AuData[i]>0
    NAuYear[i] = sum(tmp > 0)
  	MeanPxAYear[i] = mean(AuData[i][tmp])
  	}

# _Ac:Accumulated values
NAuAc = rep(0,years)
MeanPxAAc = rep(0,years)

tmpA = AuData[1]
for (i in 1:years)
   { tmp = tmpA>0
   	 NAuAc[i] = sum(tmp)
   	 MeanPxAAc[i] = mean(tmpA[tmp])
   	 tmpA = tmpA + AuData[i+1]
   	}

#Print data
NAuYear
NAuAc
MeanPxAYear
MeanPxAAc

#Get file with paper data
papData = read.table("WGonly/WGpap.csv", sep = "\t")

# AxP: Authors per paper

# _Year: values each year
NPapYear = rep(0,years)
MeanAxPYear = rep(0,years)
for (y in 1:years)
   { tpap = papData[papData[3] == (y+1995),]
   	 NPapYear[y] = nrow(tpap)
   	 MeanAxPYear[y] = mean(tpap[2])
   	}

# _Ac:Accumulated values
NPapAc = cumsum(NPapYear)
MeanAxPAc = rep(0,years)
for (y in 1:years)
   { tpap = papData[papData[3] <= (y+1995),]
   	 MeanAxPAc[y] = mean(tpap[2])
   	}

#Print data
NPapYear
NPapAc 
MeanAxPYear
MeanAxPAc

	
# Graph values

##lectura ficheros
read.table("ItAuCod.csv",colClasses = "character",header=F, encoding="latin1",sep="\t",col.names=c("cod","author"))-> ac
row.names(ac)<- ac[,1]
read.table("WGonly/WGgrph.csv",header=F, encoding="latin1",sep="\t",colClasses = "character",col.names=c("cod1","cod2","key","year"))-> TotRel

rel = TotRel[TotRel$year <=2011,]

#generar el grafo  global
graph.data.frame(rel[,1:2], directed=F,vertices=ac) -> G

summary(G)


#calculo de las componente, !Alerta la lista de grafos conexos resultante no va necessariamente en orden de tamanyo.
decompose.graph(G,max.comps=30,min.vertices=40) -> Grafo.componentes
unlist(lapply(Grafo.componentes,vcount)) -> size
unlist(lapply(Grafo.componentes,diameter)) -> diameter
unlist(lapply(Grafo.componentes,transitivity)) ->  clustering
centro<- function(G){1/closeness(G)-> dist; which.min(dist)-> c ;V(G)$author[c]}
unlist(lapply(Grafo.componentes,centro))-> centros

#Grafo.componentes <- Grafo.componentes[[ord)er(unlist(size),decreasing=T)]]
data.frame(vertices=size, diametro=diameter, clust=clustering, centro=centros)-> tabla

xtable(tabla)


#Escogemos una componente de la lista, en este caso las más grande
k <- which.max(lapply(Grafo.componentes,vcount))
gc<- Grafo.componentes[[k]]

#algunos datos sobre el grafo escogido
summary(gc)
diameter(gc)
transitivity(gc)
