#define MAXEDITIONS 16

/* Types of papers */

#define S 0
#define N 1
#define I 2
#define E 3
#define M 4


/* Cluster matrix: every author has the cluster number she belongs to 
   each edition. Editions start at 1, if years not consecutive, not 
   the same as curr_Year-First_year*/

int ClMtx[MAXEDITIONS][MAXAUTHORS];
int CurrEd;

/* Merge cluster array. number of clusters that merge with a paper */
int mergeCl[MAXCOAUTHORS];
int mergeCl_nr;

/* Type of cluster accumulated data */
TypeMtx[5][MAXEDITIONS];

int nextClnr; /* Next (new) cluster number */



/* ______Functions_______*/

int MaxClNr(n)
int n

/* Obtains the maximum cluster number of the n authors in the maxauth 
 * array */

{ int mx, i;

  mx = 0;
  
  for (i = 0; i < n; i++) 
	  if (ClMtx[CurrEd][art_auth[i]] > mx) 
		  mx = ClMtx[CurrEd][art_auth[i]];
  return(mx);
}


/*___________*/

void setcl(clnr,n)
int clnr,n;

/* Sets the current cluster number of n authors of art_auth to clnr */

{ int i;

  for (i = 0; i < n; i++) ClMtx[CurrEd][art_auth[i]] = clnr;
}


/*___________*/


void updateCurrCl()

/* Gets paper data and updates current cluster list with data */

{ int na; /* Number of authors in current paper */
  int mc; /* Max cluster number */

  na = get_all_authors();
  mc = MaxClNr();
  
  if (mc == 0) setcl(nextClnr++,na);/* New cluster */
    else setcl(mc,na); /* set all to max of cluster numbers */
}	

/*___________*/

boolean inlist(cl)
int cl, n;

/* Checks if cluster cl is in the list of merged clusters */

{ int i;
  boolean result;
  
  result = FALSE;

  for (i = 0; i < mergeCl_nr; i++) if (mergeCl[i] == cl) result  = TRUE;

  return(result);
}


/*___________*/

void PaperType(key, year, n_au)
char key[]; /* The paper key */
int year; /* Paper year */
int n_au; /* number of authors of the paper */

/* Finds out the type of the paper. Author list is already in art_auth.
   nextClnr is of a yet unasigned cluster. Prints out the paper 
   information */

{ int i;
  int ext_int; /* cluster of Extension or Internal types */
  int aucl; /* Cluster the author belonged to past edition*/
  int typecl; /* Cluster tye */
  
  /* Initialize */
  typecl = S; ext_int = 0; new = 0; mergeCl_nr = 0;
  
  /* For each author of the paper */
  for (i = 0; i < n_au; i++)
	  { aucl = ClMtx[CurrEd-1][art_auth[i]];
	    
	    switch (typecl)
	      { case S: if (aucl == 0) typecl = N; 
		              else 
					    { typecl = I;
						  ext_int = aucl;
					    }
					 break;
			case N: if (aucl != 0)
			          { typecl = E;
					    ext_int = aucl;
			          }
			          
					 break;
			case I: if (aucl == 0) typecl = E; /* Intern becomes Extension */
			         else
					   if (aucl != ext_int) /* It's a merge of ext_int and aucl */
					     { type = M;
						   mergeCl[0] = ext_int;
						   mergeCl[1] = aucl;
						   mergeCl_nr = 2;
					     }
					 /* If aucl != 0 and != ext_int no change */
					 break;
			case E: if (aucl != ext_int) /* It's a merge of ext_int and aucl */
					     { type = M;
						   mergeCl[0] = ext_int;
						   mergeCl[1] = aucl;
						   mergeCl_nr = 2;
					     }
					 /* If aucl == 0 or == ext_int no change */
					 break;
			case M: if ((aucl != 0) && (!inlist(aucl)))  /* A new custer. Add */
					     mergeCl[mergeCl_nr++] = aucl;
					break;
	      }
	  }
   /* Final type established. Add to data */
   TypeMtx[typecl][CurrEd]++;
   
   /* Print results */
   fprintf(LOGF, "%s\t%d\t",key,year);
   switch (typecl)
	 { case N: fprintf(LOGF, "New\n");
			   break;
	   case I: fprintf(LOGF, "Internal\t%d\n", ext_int);
			   break;
	   case I: fprintf(LOGF, "Extension\t%d\n", ext_int);
			   break;
	   case M: fprintf(LOGF, "Merge");
	           for (i = 0; i < mergeCl_nr; i++)  
	              fprintf(LOGF,"\t%d", mergeCl[i]);
	           fprintf(LOGF, "\n");
			   break;
     }
}

	  
	  
   
	      


/*___________*/
